﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Charts;

namespace SfChart_Zoom
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void SfChart_OnMouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            foreach (ChartAxisBase2D axis in this.SfChart.Axes)
            {
                axis.ZoomPosition = 0;
                axis.ZoomFactor = 1;
                
            }
        }

        private void Close_OnClick(object sender, RoutedEventArgs e)
        {
            ZoomingToolKit.Visibility = Visibility.Collapsed;
        }

        private bool IsPanning = true;

        private void ZoomIn_OnClick(object sender, RoutedEventArgs e)
        {
            foreach (ChartAxisBase2D axis in this.SfChart.Axes)
            {
                    axis.ZoomFactor =Math.Round(axis.ZoomFactor-0.2,1)>0.1?Math.Round(axis.ZoomFactor-0.2,1):0.2;
                    SfChart.Cursor = Cursors.Hand;
                    IsPanning = true;
            }
           
        }

        private void ZoomOut_OnClick(object sender, RoutedEventArgs e)
        {
            foreach (ChartAxisBase2D axis in this.SfChart.Axes)
            {
                    axis.ZoomFactor = Math.Round(axis.ZoomFactor + 0.2, 1) <= 1 ? Math.Round(axis.ZoomFactor + 0.2, 1) : 1;
                    SfChart.Cursor = Cursors.Hand;
                    IsPanning = true;
                    
            }
            
        }

        private void Reset_OnClick(object sender, RoutedEventArgs e)
        {
            foreach (ChartAxisBase2D axis in this.SfChart.Axes)
            {
                axis.ZoomPosition = 0;
                axis.ZoomFactor = 1;
             
            } 
        }
       

        private void SfChart_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {

           foreach (var behavior in SfChart.Behaviors)
           {
               if (behavior is CustomZoomPanBehavior)
               {
                   (behavior as CustomZoomPanBehavior).OnMouseRightButtonDown(e);
               }
           }
        }

        private void SfChart_MouseRightButtonUp(object sender, MouseButtonEventArgs e)
        {
            foreach (var behavior in SfChart.Behaviors)
            {
                if (behavior is CustomZoomPanBehavior)
                {
                    (behavior as CustomZoomPanBehavior).OnMouseRightButtonUp(e);
                }
            }
        }

        
    }
    public class model
    {
        public double ProdId { get; set; }

        public string Prodname { get; set; }

        public double Price { get; set; }

        public double Stock { get; set; }
    }

    public class CustomZoomPanBehavior : ChartZoomPanBehavior
    {
       public void OnMouseRightButtonDown(MouseButtonEventArgs e)
        {
            base.OnMouseLeftButtonDown(e);
        }
       public void OnMouseRightButtonUp(MouseButtonEventArgs e)
       {
           base.OnMouseLeftButtonUp(e);
       }
       protected override void OnMouseLeftButtonDown(MouseButtonEventArgs e)
       {
       }
    }
    public class viewmodel
    {
        public viewmodel()
        {
            this.Products = new ObservableCollection<model>();

            Products.Add(new model() { ProdId = 1, Prodname = "Rice", Price = 20, Stock = 53 });
            Products.Add(new model() { ProdId = 2, Prodname = "Wheat", Price = 22, Stock = 76 });
            Products.Add(new model() { ProdId = 3, Prodname = "Oil", Price = 30, Stock = 80 });
            Products.Add(new model() { ProdId = 4, Prodname = "Corn", Price = 26, Stock = 50 });
            Products.Add(new model() { ProdId = 5, Prodname = "Gram", Price = 36, Stock = 68 });
            Products.Add(new model() { ProdId = 6, Prodname = "Milk", Price = 20, Stock = 90 });
            Products.Add(new model() { ProdId = 7, Prodname = "Butter", Price = 40, Stock = 73 });
        }

        public ObservableCollection<model> Products { get; set; }
    }
}
